#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
	int n;
	cin>>n;
    long a[1000],b[1000],c[100][100];
    for (int i=0;i<n;i++)
    {
        cin >>a[i];
        b[i] = a[i];
    }
    sort(b,b+n);
    int t=0;
    int x2=0,y2=0;
    for (int i=0;i<n;i++)
    {
        int x=0;
        if (a[i]!=b[i])
        {
            for (int j=i;j<n;j++)
            {
                if (a[j]==b[i]) {x=j;break;}
            }
            int q=x;
            if (x%2==0) x=x/2;
            else x=x/2+1;
            int r=0;
            for (int j=i;j<x+1;j++)
            {
                swap(a[j],a[q-r]);
                r++;
            }
            c[t][0]=i;
            c[t][1]=q;
            t++;
        }
    }
    cout <<t<<endl;
    for (int i=0;i<t;i++)
    {
        cout <<c[i][0]<<" "<<c[i][1]<<endl;
    }

}
